Page MenuHomePhabricator

Homepage Mentorship: allow mentors to configure their presentation
Closed, ResolvedPublic

Description

The newcomer homepage is a feature to help newcomers get oriented when they first create their account, so they can figure out how to start editing quickly. One component of the homepage is the mentorship module, which encourages newcomers to post questions to an experienced user's talk page.

The newcomer homepage's mentorship module assigns an experienced editor to all new editors from a signup list. In the initial version, the module just says the message, "This experienced user knows you're new and can help you with editing." Our recent user research showed that newcomers wonder, "Who is my mentor? Why am I assigned them?". The module might make more sense to newcomers if mentors can configure a personal message that gets posted to all their mentees (perhaps configurable on the wiki page where they sign up to be mentors), instead of just the standard "This experienced user knows you're new and can help you with editing."

e.g. "My name is User123 and my favorite topics are sports and music. I love to help newcomers get started!"

Here is a mockup of the mentorship module: https://wikimedia.invisionapp.com/share/KUQV2QDJ8A7#/screens/350928124

Details

Related Gerrit Patches:
mediawiki/extensions/GrowthExperiments : masterFollow-up e8bdc6990597: truncate custom mentor intros, change styling
mediawiki/extensions/GrowthExperiments : masterFollow-up e8bdc6990597: fix escaping of mentor intro text
mediawiki/extensions/GrowthExperiments : masterAllow mentors to configure an intro text

Related Objects

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptApr 4 2019, 6:54 PM
MMiller_WMF updated the task description. (Show Details)Apr 6 2019, 1:07 AM
Restricted Application added a subscriber: Liuxinyu970226. · View Herald TranscriptApr 6 2019, 1:07 AM
Tgr added a subscriber: Tgr.May 15 2019, 6:53 PM

Being able to add a profile pic would also be cool.

MMiller_WMF updated the task description. (Show Details)May 16 2019, 4:47 PM
MMiller_WMF added a subscriber: Tim_WMDE.

@Tim_WMDE is working on this now at Hackathon.

Change 510996 had a related patch set uploaded (by Tim Eulitz; owner: Tim Eulitz):
[mediawiki/extensions/GrowthExperiments@master] Allow mentors to configure an intro text

https://gerrit.wikimedia.org/r/510996

Trizek-WMF added a subscriber: Trizek-WMF.EditedMay 18 2019, 9:25 AM

If not already done, the message should be limited to text.

It would be a bit disturbing to have images and more links in the mentor's presentation. If the newcomer wants to have more informations about their mentor, they can click on the link that goes to the userpage.

Also, the number of allowed characters should be limited to avoid people putting their entire resume in that field. :)

MMiller_WMF added a comment.EditedMay 18 2019, 9:41 AM

@Tim_WMDE just discussed @Trizek-WMF's comments. We decided to make it plain text only with no character limit. No character limit because it would be hard to indicate to mentors that their message is too long, and they have no way to preview the module to see that their message is cut off.

We think that the mentorship sign up pages should just have a warning at the top: "Your message can only contain plain text and it is recommended to have no more than 250 characters. Longer messages will not be cut off, but may worsen the homepage layout."

How does that sound?

Tgr added a comment.May 18 2019, 9:54 AM

Being able to add a profile pic would also be cool.

Proposal for poor man's version:

  • mentor has to upload an avatar with the expected aspect ratio (we can resize, but automatic cropping is hard)
  • mentor list is in the form * {{#mentor|<username>|<optional description>|<optional filename>}} (easy to parse with decent error handling on save, easy to extend with interest categories etc. in the future) with fallback for the current format
  • stash the parsed mentor data in the parser cache with setExtensionData

How does that sound?

Sounds good!

@Tgr, concerning avatars, I like the idea, but we need to be extremely cautious. An avatar can be perceived as nice for some people, and provocative to others. Even experienced users may not know that their favorite image can unplease someone, because of a different culture or a different educational background. So I would advise to avoid avatars for now.

Tgr added a comment.May 18 2019, 10:45 AM

I'd just ask people to limit it to actual portraits of themselves.

We think that the mentorship sign up pages should just have a warning at the top: "Your message can only contain plain text and it is recommended to have no more than 250 characters. Longer messages will not be cut off, but may worsen the homepage layout."

Speaking of advice, we should tell mentors not to said what are their favorite topics. Most people request help about general questions and a cat person may be feel not being welcomed if a dog-person mentor shows up. The phrasing should be more "I like [topic] and [topic] but I can help you about anything".

Thanks for working on this, @Tim_WMDE. I'm putting this into code review because we want it to go to production. Will you be able to work on any changes that come out of code review?

Hey, I assume the code review would not require a major code overhaul, so I should be able to squeeze that in.

@MMiller_WMF Hey, I have finally found some time to have another look at this ticket, please check out the updated code.

@Tim_WMDE could you explain technically how mentors are supposed to configure their intro message with your patch for the benefit of reviews and QA? Thanks!

@SBisson User names on the configured mentors list page can now be extended with a pipe and a custom text on the right. Using wiki text or line breaks is not possible as per the requirements I was given.

[[User:SomeMentorUser]]|This is a custom mentor text.

Change 510996 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Allow mentors to configure an intro text

https://gerrit.wikimedia.org/r/510996

Etonkovidova added subscribers: Cntlsn, Etonkovidova.

@Cntlsn - please review the following

(1) No limit on the amount of displayed text:

(2) Wikitext font options gets rendered correctly, but not bold or italic text (users are not informed that such font options won't be displayed properly):

Other editing options - links, images etc will be displayed as wikitext.

Thanks @Etonkovidova.

Here are my comments about it:

  1. The maximum length for the mentor message should be 240 characters -- it is not an arbitrary decision:
    • 240 characters is the length of a tweet (which is a good reference for short messages)
    • Many (if not most) personal messages by teahouse hosts fall into the 240 threshold
    • It works fine in the context of the mentorship module layout
  2. I don't think we should render some wikitext font options in the messages, like for instance monospace, superscript...
    • some could be potentially useful (I'm thinking of bold), but if we need to decide between featuring them or not I would go with the latter, so we avoid potential typographic mess when displaying the messages
    • It could be interesting to show links (just like TeaHouse do) but I don't think it is necessary
    • images should not be displayed, neither as image nor as wikitext
  3. The text styling should be:
    • font-size: 18px
    • font-style: italic
    • color: #54595D or @colorGray5
    • The text should be preceded and followed by quotation marks

I also think it could be helpful to write a very short guide to be posted on the mentors page on how to write their messages (plus what is and what is not supported typography-wise).

Moving it back to ready for development because of the text styling, but looping in @MMiller_WMF to decide how / when to proceed with the rest, and if we eventually need to break this into more tasks.

Change 519737 had a related patch set uploaded (by Catrope; owner: Catrope):
[mediawiki/extensions/GrowthExperiments@master] Follow-up e8bdc6990597: fix escaping of mentor intro text

https://gerrit.wikimedia.org/r/519737

Change 519739 had a related patch set uploaded (by Catrope; owner: Catrope):
[mediawiki/extensions/GrowthExperiments@master] [WIP] Follow-up e8bdc6990597: truncate custom mentor intros, change styling

https://gerrit.wikimedia.org/r/519739

Thanks @Etonkovidova.
Here are my comments about it:

  1. The maximum length for the mentor message should be 240 characters -- it is not an arbitrary decision:

Done in my follow-up patch.

  1. I don't think we should render some wikitext font options in the messages, like for instance monospace, superscript...
    • some could be potentially useful (I'm thinking of bold), but if we need to decide between featuring them or not I would go with the latter, so we avoid potential typographic mess when displaying the messages
    • It could be interesting to show links (just like TeaHouse do) but I don't think it is necessary
    • images should not be displayed, neither as image nor as wikitext

What @Etonkovidova found here was a bug (and a security issue!), my patch fixes it. With my patch, wikitext is not interpreted at all.

  1. The text styling should be:
    • font-size: 18px
    • font-style: italic
    • color: #54595D or @colorGray5
    • The text should be preceded and followed by quotation marks

Should this apply only to customized intro texts, or to the default intro text as well? The default intro text is This experienced user knows you're new and can help you with editing., and is displayed in this location if the mentor doesn't have a custom intro text.

For consistency (and, honestly, out of laziness, but laziness often causes consistency as a side effect), my patch applies this styling to both (except for the quotation marks, those are for custom intros only), But we can apply it only to custom ones and leave the styling of the default intro text as-is if you like, it's just more work.

I also think it could be helpful to write a very short guide to be posted on the mentors page on how to write their messages (plus what is and what is not supported typography-wise).

If someone writes copy for that, we could manually post that on each wiki's mentor page, and/or write it on a documentation page on mediawiki.org somewhere. But this is not a software request, so let's break it out into a separate task?

Done in my follow-up patch.

@Catrope sounds great, thanks!

What @Etonkovidova found here was a bug (and a security issue!), my patch fixes it. With my patch, wikitext is not interpreted at all.

Not even links?

Should this apply only to customized intro texts, or to the default intro text as well? The default intro text is This experienced user knows you're new and can help you with editing., and is displayed in this location if the mentor doesn't have a custom intro text.
For consistency (and, honestly, out of laziness, but laziness often causes consistency as a side effect), my patch applies this styling to both (except for the quotation marks, those are for custom intros only), But we can apply it only to custom ones and leave the styling of the default intro text as-is if you like, it's just more work.

Actually I don't think it was ever decided to show This experienced user knows you're new and can help you with editing. in case the mentor wouldn't configure a custom welcome statement. The current mockups for the Mentorship module (desktop -- mobile), as per https://phabricator.wikimedia.org/T223215#5219248, display a new intro text All newcomers are assigned an experienced mentor to help them edit. above the mentor's name and until the user has clicked on the CTA, at which point it will be hidden. Actually the specs for T223215 have not been frozen yet, and the specs are not listed in the task description, because the last comment in the conversation is still waiting for input by @MMiller_WMF

But I think you're raising a good point, and I would opt for your "lazy" solution. Resulting in:

(Same for mobile)

While we're here, the mentor's statement text and CTA should be indented ;)
You can check Zeplin for specs!

I also think it could be helpful to write a very short guide to be posted on the mentors page on how to write their messages (plus what is and what is not supported typography-wise).

If someone writes copy for that, we could manually post that on each wiki's mentor page, and/or write it on a documentation page on mediawiki.org somewhere. But this is not a software request, so let's break it out into a separate task?

Will do!

@Catrope Alright, I guess we should have browsed the task conversation with more attention.
Here you can find more specs.
If you agree with what's in the comment above I will update the task description.

Change 519737 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Follow-up e8bdc6990597: fix escaping of mentor intro text

https://gerrit.wikimedia.org/r/519737

We think that the mentorship sign up pages should just have a warning at the top: "Your message can only contain plain text and it is recommended to have no more than 250 characters. Longer messages will not be cut off, but may worsen the homepage layout."

This is something that should be added to the relevant mentor list wiki pages, so we should ask the ambassadors to do that.

Done in my follow-up patch.

@Catrope sounds great, thanks!

What @Etonkovidova found here was a bug (and a security issue!), my patch fixes it. With my patch, wikitext is not interpreted at all.

Not even links?

Nope, nothing. In theory, we could use the edit summary parser (which only allows links and no other markup), but I would much rather we either choose to not allow any markup at all, or allow everything.

Should this apply only to customized intro texts, or to the default intro text as well? The default intro text is This experienced user knows you're new and can help you with editing., and is displayed in this location if the mentor doesn't have a custom intro text.

Actually I don't think it was ever decided to show This experienced user knows you're new and can help you with editing. in case the mentor wouldn't configure a custom welcome statement.

We assumed that that's how it would work, since that's the text that's shown in all cases in production right now.

The current mockups for the Mentorship module (desktop -- mobile), as per https://phabricator.wikimedia.org/T223215#5219248, display a new intro text All newcomers are assigned an experienced mentor to help them edit. above the mentor's name and until the user has clicked on the CTA, at which point it will be hidden. Actually the specs for T223215 have not been frozen yet, and the specs are not listed in the task description, because the last comment in the conversation is still waiting for input by @MMiller_WMF

I didn't know about that task, probably because it's still in the design stage. If you/Marshall want to wait until T223215 has been decided on and implemented, we can do that, but given that you gave me a "v1.1" mockup I'm guessing you want us to move ahead with custom intro texts now and do T223215 later.

But I think you're raising a good point, and I would opt for your "lazy" solution. Resulting in:

(Same for mobile)

That's a text change from what we currently have, though, and T223215 is going to change this text again. I'd rather not change the text twice in rapid succession, to avoid translator whiplash. So let's either keep it the same for now and change it later once T223215 happens, or change it now to the new text from T223215.

While we're here, the mentor's statement text and CTA should be indented ;)
You can check Zeplin for specs!

Patch updated:

Let's implement the work on this task as a separate iteration than the future work from T223215. Therefore, I think in this task, we should apply the new styling (italics, and quotes for custom messages), along with the old default message ("This experienced users know you're new..."). I think the 240 character limit is fine, and I made this separate task (T227232) so that @Trizek-WMF can pursue how to get the guidelines at the top of mentor sign-up pages.

I just want to make sure -- if mentors who have already signed up (e.g. like on this page), do nothing and leave their sign-ups alone, they'll still show the default message, right?

I'm looking forward to trying this out!

Change 519739 merged by jenkins-bot:
[mediawiki/extensions/GrowthExperiments@master] Follow-up e8bdc6990597: truncate custom mentor intros, change styling

https://gerrit.wikimedia.org/r/519739

@SBisson @kostajh -- I wanted to bump my question above: I just want to make sure -- if mentors who have already signed up (e.g. like on this page), do nothing and leave their sign-ups alone, they'll still show the default message, right?

@SBisson @kostajh -- I wanted to bump my question above: I just want to make sure -- if mentors who have already signed up (e.g. like on this page), do nothing and leave their sign-ups alone, they'll still show the default message, right?

Yes, the default message will be shown for mentors who did not add any additional text.

@Mmiller - I am moving this task to PM Review column since the current iteration of mentor description seems to be done and separate phab tasks are filed to address future improvements.

T227535: Homepage Mentorship - issues with parsing mentor added descriptions has two issues that might be common cases when mentors start adding descriptions. The cases are still outside of the scope of this task.

  1. I don't think we should render some wikitext font options in the messages, like for instance monospace, superscript...
    • some could be potentially useful (I'm thinking of bold), but if we need to decide between featuring them or not I would go with the latter, so we avoid potential typographic mess when displaying the messages
    • It could be interesting to show links (just like TeaHouse do) but I don't think it is necessary
    • images should not be displayed, neither as image nor as wikitext

What @Etonkovidova found here was a bug (and a security issue!), my patch fixes it. With my patch, wikitext is not interpreted at all

@Catrope - by "wikitext is not interpreted at all", did you mean that wikitext markup is still displayed?

Thanks, @Etonkovidova. I'll leave this in my column until it is safely in production.

@kostajh @SBisson @Catrope -- although I just tried this in beta and it looks okay, I'm wondering what actually happens in the software for languages that don't have italics, like Korean and Arabic. How do the italics get rendered?

Cntlsn added a comment.EditedJul 9 2019, 10:17 AM

@MMiller_WMF just chiming in to say that Korean and Arabic do render correctly in italic:

So I don't think it is a technical issue. I guess the question is more about if it is correct to italicize in these languages, which I'm not too sure about. I did a bit of research and there are different opinions on the topic, but I see examples of italic korean and arabic (eg. https://en.wikipedia.org/wiki/Italic_type#Italics_within_italics)

I have asked the design team about what our best practice would be in this case, and will get back here once I have an answer.

@Catrope @kostajh @SBisson what is your experience with this?

@MMiller_WMF just chiming in to say that Korean and Arabic do render correctly in italic:

@revi and @Dyolf77_WMF, is it correct?

@revi and @Dyolf77_WMF, is it correct?

Yes, the Arabic is correctly rendered in italic!

revi added a comment.Jul 9 2019, 9:44 PM

We discussed this while ago (maybe search for checkin logs) and italic in Korean language is in most cases (almost always) inappropriate.

Thanks @Dyolf77_WMF and @revi for your input on this, very helpful!

@Catrope @kostajh @SBisson considering we might have different scenarios here, would it be a good idea to use the :lang() selector?
Is it used anywhere in the codebase already?

thanks @Tgr I didn't know about the mediawiki code search tool, it's awesome!

Trizek-WMF added a comment.EditedJul 10 2019, 12:43 PM

I'm preparing the documentation for this feature (T227232).

How mentors describe themselves, from a user perspective? I've seen on T220145#5192925 some suggestions, but what is the current implementation?

I've seem something like [[User:ET125]]|Description on Beta. Will it be the final version?

For simplification, can't we remove the brackets around the username? It would avoid people from being tempted to use wikitext in the description.

I've seem something like [[User:ET125]]|Description on Beta. Will it be the final version?

Yes, that is how it currently works. We may be able to change the format if there's a desire for that, but that's the format that's used in the current implementation (which is going into production today).

For simplification, can't we remove the brackets around the username? It would avoid people from being tempted to use wikitext in the description.

No, not without making the format a lot more rigid. The big advantage of requiring brackets around the username is that we can get the list of mentors by simply asking "which links to the User: namespace appear on this page", and that way we don't have to parse the page ourselves, or impose any restrictions on the format of the page. This makes things simpler both on the implementation side (by using the existing parser) and on the usage side (because the format is very flexible).

The default description is displayed, see Task T228991

Tim_WMDE removed a subscriber: Tim_WMDE.Jul 30 2019, 5:42 PM
MMiller_WMF closed this task as Resolved.Aug 7 2019, 5:28 PM

This is good in production. Thank you!